package org.rcisoft.test;

import com.alibaba.fastjson.JSON;
import com.alibaba.fastjson.JSONArray;
import com.alibaba.fastjson.JSONObject;
import org.apache.commons.io.FileUtils;
import org.apache.commons.lang3.StringUtils;
import org.junit.runner.RunWith;
import org.rcisoft.business.manage.dao.SysCityRepository;
import org.rcisoft.business.manage.entity.SysCity;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.boot.test.context.SpringBootTest;
import org.springframework.test.annotation.Rollback;
import org.springframework.test.context.junit4.SpringRunner;
import org.springframework.transaction.annotation.Transactional;
import tk.mybatis.mapper.entity.Example;

import java.io.*;
import java.util.List;

/**
 * Created by JiChao on 2018/5/7.
 */
@SpringBootTest
@RunWith(SpringRunner.class)
public class CityCodeTest {

    @Autowired
    private SysCityRepository sysCityRepository;

    @org.junit.Test
    @Transactional
//    @Rollback(false)
    public void importCityCode() throws IOException {
        int[] result = {0};
        System.out.println("-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*");
        //读取txt文件
        String sb = FileUtils.readFileToString(new File("C:\\Users\\JiChao\\Desktop\\城市代码.txt"), "GB2312");
        //json对象
        JSONArray codeJsonArray = JSON.parseArray(sb);
        //所有城市
        List<SysCity> cityList = sysCityRepository.selectAll();
        cityList.forEach(sysCity -> {
            String cityName = sysCity.getName();
            codeJsonArray.forEach(object -> {
                JSONObject codeJsonObject = (JSONObject) object;
                String codeName = (String) codeJsonObject.get("townName");
                if (StringUtils.equals(cityName, codeName)) {
                    String code = (String) codeJsonObject.get("townID");
                    sysCity.setCode(code);
                    Example e = new Example(SysCity.class);
                    e.createCriteria().andEqualTo("id", sysCity.getId());
                    result[0] += sysCityRepository.updateByExample(sysCity, e);
                    return;
                }
            });
        });
        System.out.println("最终更新结果：" + result[0] + "条记录");
    }

}
